/*
>>>>>>>>>>LOGICIEL DE TRAITEMENT DE TEXTE<<<<<<<<<<<<<<<<<<<<<<<<
>>>>>>>>>>          CHERE AMIE           <<<<<<<<<<<<<<<<<<<<<<<

QUI TRADUIT DES ENTREES CLAVIERS EN LETTRES SVG PUIS SAUVEGARDE LE FICHIER EN VECTORIEL (PDF)
POUR ENSUITE POUVOIR LE TRAITER DANS ILLUSTRATOR OU/ET DANS SILHOUETTE STUDIO POUR 
TRACES NUMERIQUE A LA CAMEO

>>>>>>TYPO OCR-C SUR LA BASE DE LA OCR-B <<<<<<<<<<
par Adrian Frutiger for Monotype en 1968 <3
Possibilité de modifier la typo : pour cela, dans le fichier data,
remplacer les caractères svg par d'autres (je n'ai pas encore essayé, 
c'est à vos risques et périls ahaha).


POSSIBILITE D'INVERSER LES LETTRES /POUR TYPO INCLUSIVE PAR EX 
avec les flèches droite et gauche

OU DE FAIRE VARIER LEUR LARGEUR (EFFET PARAMETRIQUE)
avec les fleches haut et bas
4 TAILLES DE CARACTERES PARAMETREES 
hauteur fixe 20px
taille 1 : largeur 5px
taille 2 : largeur 10px
taille 3 : largeur 20px
taille 4 : largeur 40px

LE CARACTERE O est spécial
LES CARACTERES B,P et R sont spéciaux et sont obtenus par dessin processing

LES CARACTERES NE S'EFFACENT PAS
en appuyant sur delete, ils seront barrés

POUR LA SAUVEGARDE PDF, DE-COMMENTER LA LIGNE beginRecord dans le setup
et bien fermer le display par echap et pas autrement

BUGS À CORRIGER :
* accents grave, trema et circonflexe sont tracés 2 fois (circonflexe pas symétrique en taille 1)
il faudrait que l'accent se tape avant de tracer la lettre, comme c'est le cas sur mac sur traitement de texte classique
* nombreux problèmes d'espacements, surtout au niveau de la ponctuation.
* le delete est pas super clean (et il faudrait qu'il puisse effacer plusieurs caractères)
* lettres duppliquées par fois, histoire de frame ??

AMELIORATIONS KIFFANTES : 
* le e dans l'o >> œ
* des lettres qui se superposent pour faire de l'écriture inclusive++, ou des ligatures


VERSION 3
3 JUIN 2022

ANNAB JUNG
annabelle.jung@proton.me
https://pvc.hotglue.me/

merci à Marion Renerre pour l'énergie et merci à Mahé Boissin pour l'inspi

désolé.e aux puristes, des fois j'ai codé ça comme un cochon et j'ai pas dû utiliser
la méthode la plus économe en lignes de code, nettoyez si vous le voulez :)
*/

import processing.pdf.*;
import java.util.Calendar;
import processing.svg.*;

PShape a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z;
PShape Cc; //le C cédille
PShape zero, un, deux, trois, quatre, cink, six, sept, huit, neuf, koi; // koi = ?
int pclarge = 2; //facteur de largeur des caractères

int margeX = 4; //marge entre lettres
int incrLettreFixe = 14; //10 (largeur caractère de base) + margeX 
int hauteurY = 20; 
int incrementY = 30; // hauteur d'interligne
int espace = 12;
int guillemet = 0; // compteur pour ouvrir et fermer les guillemets

int posX = 5;
int posY = 5;

float sym = 1;

boolean newletter = false;
boolean lettrefixe = false;
boolean doubletap = false; 

void setup() {
  size(700, 700);
  background(250);
  loadLetter();
  koi = loadShape("data/koi.svg");
  beginRecord(PDF, "PDFrec/" + timestamp()+".pdf");

}

void draw() {
    
  smooth();
  noFill();  // pas de remplissage
  stroke(0); // ligne noir
  strokeCap(ROUND);
  strokeJoin(ROUND);
  strokeWeight(1);
  
  if (newletter) {
    switch(key){
      //LETTRES VARIABLES >> A E F H K L M N T V W X Y Z
      case 'a' :
         drawLetter(a,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'e' :
         drawLetter(e,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'f' :
         drawLetter(f,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'h' :
         drawLetter(h,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'k' :
         drawLetter(k,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'l' :
         drawLetter(l,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'm' :
         drawLetter(m,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'n' :
         drawLetter(n,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 't' :
         drawLetter(t,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'v' :
         drawLetter(v,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'w' :
         drawLetter(w,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'x' :
         drawLetter(x,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'y' :
         drawLetter(y,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'z' :
         drawLetter(z,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
         
      //LETTRES SPECIALES B P R
      case 'b' :
         drawB(posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         if ((pclarge==2)&&(sym==1)) posX +=margeX;
         break;
      case 'p' :
         drawP(posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;;
         if ((pclarge==2)&&(sym==1)) posX +=margeX;
         break;
      case 'r' :
         drawR(posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;;
         if ((pclarge==2)&&(sym==1)) posX +=margeX;
         break;
         
      // la lettre O et le chiffre zero
      case 'o' :
      case '0' :
        if (pclarge==4){
         ellipseMode(CORNER);
         ellipse(posX,posY,hauteurY,hauteurY);
         } else if (pclarge==8){
          ellipseMode(CORNER);
          arc(posX,posY,hauteurY,hauteurY,HALF_PI, PI+HALF_PI);
          arc(posX+hauteurY,posY,hauteurY,hauteurY,-HALF_PI, HALF_PI);
          
          line(posX+10,posY,posX+30,posY);
          line(posX+10,posY+hauteurY,posX+30,posY+hauteurY);
          
         } else {
         drawLetter(o,posX,posY,pclarge,sym);
         }
         posX += pclarge*5+margeX;
         ellipseMode(CENTER);
         lettrefixe=false;
         break;
      
      // la lettre Q dérivée de O
      case 'q' :
        if (pclarge==4){
         ellipseMode(CORNER);
         ellipse(posX,posY,hauteurY,hauteurY);
         line (posX+hauteurY,posY+hauteurY, posX+7*hauteurY/8,posY+7*hauteurY/8);
         
        } else if (pclarge==8){
          ellipseMode(CORNER);
          arc(posX,posY,hauteurY,hauteurY,HALF_PI, PI+HALF_PI);
          arc(posX+hauteurY,posY,hauteurY,hauteurY,-HALF_PI, HALF_PI);
          
          line(posX+10,posY,posX+30,posY);
          line(posX+10,posY+hauteurY,posX+30,posY+hauteurY);
          line (posX+pclarge*5-3,posY+hauteurY-3, posX+pclarge*5,posY+hauteurY);
          
        } else {
         drawLetter(q,posX,posY,pclarge,sym);
        }
         posX += pclarge*5+margeX;
         ellipseMode(CENTER);
         lettrefixe=false;
         break;
      
      // LETTRES FIXES >>  (C D G) I (J Q S U)
      // dans l'ancienne version, les curvilignes n'existaient qu'en taille 2
      // à l'usage, je me suis rendue compte que ça fonctionnait quand même de déformer les courbes
      // pour revenir à une forme non étirée des courbes, remettre les lignes de commande :
      // drawLetter(c,posX,posY,2,sym);
      // posX += incrLettreFixe;
      // lettrefixe=true;
      
      case 'c' :
         drawLetter(c,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'ç' :
         drawLetter(Cc,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'd' : 
         drawLetter(d,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'g' :
         drawLetter(g,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break; 
      case 'j' :
         drawLetter(j,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 's' : 
         drawLetter(s,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
      case 'u' : 
         drawLetter(u,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=false;
         break;
       
      // CAS PARTICULIER LE I
      case 'i' :
        if (pclarge<4){
           pushMatrix();
           translate(posX+pclarge*margeX/2-3, posY+hauteurY/2);
           line(0,-hauteurY/2,0,hauteurY/2);
           //line(-pclarge*(margeX-2),0,pclarge*(margeX-2),0);
           popMatrix();
           posX += pclarge*margeX-1;
           lettrefixe=false;
        } else {
           drawLetter(i,posX,posY,2,sym);
           posX += incrLettreFixe;
           lettrefixe=true;
        }
        break;   
      
      //CHIFFRES VARIABLES
      case '°' : // zero en mode numéro n°
         ellipse(posX+margeX,posY+margeX,2*margeX,2*margeX); 
         posX += incrLettreFixe;
         break;
      case '1' : 
         drawLetter(un,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=true;
         break;
      case '2' : 
         drawLetter(deux,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=true;
         break;
      case '3' :
         drawLetter(trois,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=true;
         break;
      case '4' : 
         drawLetter(quatre,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=true;
         break;
      case '5' :
         drawLetter(cink,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=true;
         break;
      case '6' : 
         drawLetter(six,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=true;
         break;
      case '7' : 
         drawLetter(sept,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=true;
         break;
      case '8' : 
         drawLetter(huit,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=true;
         break;
      case '9' : 
         drawLetter(neuf,posX,posY,pclarge,sym);
         posX += pclarge*5+margeX;
         lettrefixe=true;
         break;
      
      // ACCENTS
      case '-' : //accent droit
        if (lettrefixe){
          line(posX-12,posY-3,posX-6,posY-3);
        } else {
         line(posX-4,posY-3,posX-(pclarge*5+margeX),posY-3);
        }
        break;
      case '`' : //accent grave
        if (lettrefixe){
          line(posX-12,posY-4,posX-6,posY-1);
        } else {
         line(posX-4,posY-1,posX-(pclarge*5+margeX),posY-4);
        }
        doubletap = true; //booléen qui me permettrait de ne pas tracer 2 fois l'accent
        break;
      case 'ù' : //accent aigü
        if (lettrefixe){
          line(posX-12,posY-1,posX-6,posY-4);
        } else {
         line(posX-4,posY-4,posX-(pclarge*5+margeX),posY-1);
        }
        break;
      case '^' : //accent circonflexe
        if (lettrefixe){
          line(posX-12,posY-1,posX-9,posY-4);
          line(posX-9,posY-4,posX-6,posY-1);
        } else {
           line(posX-(pclarge*5+margeX),posY-1,posX -((pclarge*5+margeX)/2)-2,posY-4);
           line(posX-4,posY-1,posX -((pclarge*5+margeX)/2)-2,posY-4);
        }
        doubletap = true;
        break;
      case '¨' : //accent trema
        if (lettrefixe){
           ellipse(posX-6,posY-1,1,1);
           ellipse(posX-12,posY-1,1,1);
        } else {
           ellipse(posX-2-2*(pclarge*5+margeX)/3,posY-1,1,1);
           ellipse(posX-2-(pclarge*5+margeX)/3,posY-1,1,1);
        }
        doubletap = true;
        break;
         
      // PONCTUATION
      case '(' : //parenthèse ouvrante
         arc(posX+hauteurY+margeX,posY+hauteurY/2,2*hauteurY,2*hauteurY,PI-PI/6, PI+PI/6);
         posX += 2*margeX;
         break;
      case ')' : //parenthèse fermante
         arc(posX-hauteurY,posY+hauteurY/2,2*hauteurY,2*hauteurY,-PI/6, PI/6);
         posX += 2*margeX;
         break;
      case '.' : //point
         ellipse(posX,posY+hauteurY-1,1,1);
         posX += 6;
         break;
      case ':' : //deux points
         ellipse(posX,posY+hauteurY-1,1,1);
         ellipse(posX,posY+hauteurY/2-1,1,1);
         posX += 6;
         break;
      case '!' : //point d'exclamation
         ellipse(posX,posY+hauteurY-1,1,1);
         line(posX,posY+2*hauteurY/3,posX,posY);
         posX += 6;
         break;
      case ';' : //point virgule
         line(posX,posY+hauteurY-1, posX-2,posY+hauteurY+4);
         ellipse(posX,posY+hauteurY/2-1,1,1);
         posX += 6;
         break;
      case ',' : //virgule
         line(posX,posY+hauteurY-1, posX-2,posY+hauteurY+4);
         posX += 6;
         break;
      case '\'' : //apostrophe
         line(posX,posY, posX-1,posY+4);
         posX += margeX;
         break;
      case '+' : //plus variable
         pushMatrix();
         translate(posX+pclarge*margeX/2-3, posY+hauteurY/2);
         line(0,-hauteurY/2+1,0,hauteurY/2-1);
         line(-pclarge*(margeX-2),0,pclarge*(margeX-2),0);
         popMatrix();
         posX += pclarge*margeX-1;
         break;
      case '_' : //tiret
         line(posX-1,posY+hauteurY/2,posX+pclarge*margeX-2,posY+hauteurY/2);
         posX += pclarge*margeX;
         break;
      case '?' : //point d'interrogation
        koi.disableStyle();
        shape(koi, posX, posY, 10, 20);
        posX += 4*margeX;
        break;
      
         
      // SYMBOLES
      case '*' : //astérisque
         if (pclarge>1){
           pushMatrix();
           translate(posX+pclarge*margeX/2-3, posY+hauteurY/2);
           line(0,-hauteurY/2+1,0,hauteurY/2-1);
           line(-pclarge*(margeX-2),0,pclarge*(margeX-2),0);
           rotate(radians(45));
           line(-pclarge*2,0,pclarge*2,0);
           rotate(radians(90));
           line(-pclarge*2,0,pclarge*2,0);
           popMatrix();
         } else { // si pclarge = 1, l'asterique passe en exposant
           pushMatrix();
           translate(posX+pclarge*margeX/2-3, posY+hauteurY/4);
           line(0,-5,0,5);
           line(-5,0,5,0);
           rotate(radians(45));
           line(-3,0,3,0);
           rotate(radians(90));
           line(-3,0,3,0);
           popMatrix();
         }
         posX += pclarge*margeX-1;
         break;
      
      case '$' : //astérisque à 5 branches
         pushMatrix();
         translate(posX+pclarge*margeX/2-3, posY+hauteurY/2);
         line(0,0,0,-hauteurY/2);
         line(0,0,pclarge*margeX/2-1,hauteurY/2);
         line(0,0,-pclarge*margeX/2+1,hauteurY/2);
         rotate(radians(72));
         line(0,0,0,-pclarge*2);
         rotate(radians(400));
         line(0,0,0,pclarge*2);
         popMatrix();
         posX += pclarge*margeX-1;
         break;
      
      case 'H' : //flèche vers le haut en faisant un H maj
         pushMatrix();
         translate(posX+pclarge*margeX/2, posY);
         line(0,0,0,hauteurY);
         line(0,0,-pclarge*margeX/2,hauteurY/2);
         line(0,0,pclarge*margeX/2,hauteurY/2);
         popMatrix();
         posX += pclarge*5+(margeX-pclarge);
         lettrefixe=false;
         break;
      case 'B' : //flèche vers le bas en faisant un B maj
         pushMatrix();
         translate(posX+pclarge*margeX/2, posY+hauteurY);
         line(0,0,0,-hauteurY);
         line(0,0,-pclarge*margeX/2,-hauteurY/2);
         line(0,0,pclarge*margeX/2,-hauteurY/2);
         popMatrix();
         posX += pclarge*5+(margeX-pclarge);
         lettrefixe=false;
         break;
      

      case 'X' : //croix en faisant un X majuscule
         pushMatrix();
         translate(posX+pclarge*margeX/2-3, posY+hauteurY/2);
         rotate(radians(45));
         line(-pclarge*2,0,pclarge*2,0);
         rotate(radians(90));
         line(-pclarge*2,0,pclarge*2,0);
         popMatrix();
         posX += pclarge*margeX-1;
         break;
      case '<' : // chevron ouvrant
         pushMatrix();
         translate(posX+2, posY+hauteurY/2);
         line(0,0,pclarge*2,-hauteurY/2);
         line(0,0,pclarge*2,hauteurY/2);
         popMatrix();
         posX += pclarge*margeX+(margeX-pclarge);
         break;
      case '>' : // chevron fermant
         pushMatrix();
         translate(posX+pclarge-margeX, posY);
         line(0,0,pclarge*2,hauteurY/2);
         line(0,hauteurY,pclarge*2,hauteurY/2);
         popMatrix();
         posX += pclarge*margeX+(margeX-pclarge);
         break;
      case '"' : // guillement ouvrant ou fermant
         guillemet += 1;
         if (guillemet%2 == 0){ //compteur de guillemet pair càd guillemet fermant
           pushMatrix();
           translate(posX, posY);
           line(0,0,pclarge*2,hauteurY/2);
           line(0,hauteurY,pclarge*2,hauteurY/2);
           translate(margeX+pclarge/2, 0);
           line(0,0,pclarge*2,hauteurY/2);
           line(0,hauteurY,pclarge*2,hauteurY/2);
           popMatrix();
         } else { //compteur de guillemet impair càd guillemet ouvrant
           pushMatrix();
           translate(posX+pclarge-margeX, posY+hauteurY/2);
           line(0,0,pclarge*2,-hauteurY/2);
           line(0,0,pclarge*2,hauteurY/2);
           translate(margeX+pclarge/2, 0);
           line(0,0,pclarge*2,-hauteurY/2);
           line(0,0,pclarge*2,hauteurY/2);
           popMatrix();
         }
         // incrémentation du curseur
         posX += pclarge*margeX+(margeX-pclarge);
         break;
      
      
      // ESPACE
      case ' ' :
        if (pclarge <2){
         posX += espace/2;
        } else {
          posX += espace;
        }
        break;
    } // fin du switch
    
    // retour à la ligne
    if ((key == ENTER)||(posX >= width-10)){
        posX = 5;
        posY+= incrementY;
    }
    //effacer
    if (key == 8){
      if (lettrefixe){ // si la lettre est fixe il faut effacer une largeur normale
        for (int i = 1; i < incrementY-4; i = i+3) {
          line(posX-4,posY+i,posX-incrLettreFixe,posY+i);
        }
      } else {
        for (int i = 1; i < incrementY-4; i = i+3) {
          line(posX-4,posY+i,posX-(pclarge*5+margeX),posY+i);
        }
      }
    }
    if (key == CODED) {
      //augmenter ou diminuer la largeur des lettres
      if ((keyCode == UP)&&(pclarge<8)) {
        pclarge = pclarge*2;
      } else if ((keyCode == DOWN)&&(pclarge>1)) {
        pclarge = pclarge/2;
      }
      println("pclarge="+pclarge);
      //retourner les lettres
      if (keyCode == LEFT){
       sym = -1;
       println("lettres inversées");
      } else if (keyCode == RIGHT) sym = 1 ;
      
    }
    /*
    trouver une solution au problème des doubletap d'accent
    if (doubletap) newletter = true;
    println("doubletap"+doubletap);
    */
    newletter = false;
  } 
    
}

//appuyer sur echap pour fermer le display et enregistrer correctement le PDF
void keyPressed() {
  if (keyCode == ESC) {
    endRecord();
    exit();
  } else newletter = true;
}

// permet de nommer les fichiers pdf d'après leur heure de creation
String timestamp() {
  Calendar now = Calendar.getInstance();
  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
}
